package lectura_ficheros;

/** Esta clase crea un tipo de JTextField que consideran al tabulador como un 
 * caracter, en lugar como una tecla de funcion especial
*/
import java.awt.event.KeyEvent;

import javax.swing.JTextField;

public class JTextFieldTabulador extends JTextField {
	private static final long serialVersionUID = 1L;

	/**
	 * Constructor
	 * */
	public JTextFieldTabulador (){
		super (null, null, 0);
	} 
	
	/**
	 * Constructor por parametros
	 * @param str Nombre del campo
	 * */
	public JTextFieldTabulador (String str){
		super (null, str, 0);
	} 
	
	/**
	 * Constructor por parametros
	 * @param cols Numero de columnas del campo
	 * */
	public JTextFieldTabulador (int cols){
		super (null, null, cols);
	} 
	
	/**
	 * Constructor por parametros
	 * @param str Nombre del campo
	 * @param cols Numero de columnas del campo
	 * */
	public JTextFieldTabulador (String str, int cols){
		super (null, str, cols);
	} 
	
	/**
	 * Funcion que ignora la funcion de tecla especial cuando se pulsa el tabulador
	 * @param kvt Evento generado al pulsar una tecla
	 * */
	public void processComponentKeyEvent (KeyEvent kvt){
		switch (kvt.getID()){
		case KeyEvent.KEY_PRESSED:
		case KeyEvent.KEY_RELEASED:
			if (kvt.getKeyCode() == KeyEvent.VK_TAB ){
				this.setText(this.getText() + "\t");
				return;
			}
			break;
		case KeyEvent.KEY_TYPED:
			if (kvt.getKeyChar() == '\t'){
				this.setText(this.getText() + "\t");
				return;
			}
			break;
		}
		super.processComponentKeyEvent(kvt);
		
	}
}
