package lectura_ficheros;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import manejoXML.ArchivoXML;

/**
 * Crea un Frame con campos de texto editables para modificar la informacion
 * obtenida automaticamente de la lectura de un fichero por <b>Explorador</b>
 * */
public class PanelOpciones extends JPanel implements ActionListener{

	private static final long serialVersionUID = 1L;
	
	ContenidoFichero contenido;
	File file;
	
	JFrame frame;
	GridBagLayout gridbag;
	
	JTextField tf1,tf2,tf3;//,tf4;
	JButton b1,b2,b3;

	 /**
	 * Constructor por parametros
	 * @param nombre_panel Nombre del panel
	 * @param file Nombre del fichero del que extraer los datos
	 * @param cf Contenido estructurado del fichero <i>file</i>
	 */
	public PanelOpciones (String nombre_panel, File file, ContenidoFichero cf){ 
		
		super (new GridBagLayout());
		this.contenido = cf;
		this.file = file;
		
		gridbag = new GridBagLayout();
		
        frame = new JFrame(nombre_panel);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
    	//etiquetas
        JLabel etiq1 = new JLabel( "Objeto de estudio:" );
        JLabel etiq2 = new JLabel( "Unidades:" );
        JLabel etiq3 = new JLabel( "Fecha:" );

        //campos de texto
        tf1 = new JTextField(60);
        tf2 = new JTextField(60);
        tf3 = new JTextField(60);
        
        //Rellenar los campos de texto con los datos apropiados
        //campos de texto
        tf1.setText(contenido.metadatos[0]);	//TODO cambiar aqui si modifica la estructura
        tf2.setText(contenido.metadatos[5]);
        tf3.setText(contenido.metadatos[4]);
        tf3.setEditable(false);
        
        //botones
        b1 = new JButton( "Cargar datos" );
        b1.addActionListener(this);
        
        setLayout( gridbag );
        
        //aadimos los componentes a "frame" para formar el JPanel
        addComponente( etiq1, 0,0,1,1 );	addComponente( tf1, 2,0,1,1 );
        addComponente( etiq2, 0,1,1,1);     addComponente( tf2, 2,1,1,1);
        addComponente( etiq3, 0,2,1,1);     addComponente( tf3, 2,2,1,1);
        addComponente( b1, 2,4,1,1);
        
        //Add content to the window.
        frame.add(this);

        //Display the window.
        frame.pack();
        frame.setVisible(true);
        
        }


	/**
	 * Aade un componente a un panel del tipo GridBagPanel
	 * @param comp Componente a aadir
	 * @param gridx valor <i>x</i> del grid
	 * @param gridy valor <i>y</i> del grid
	 * @param gridw valor de la anchura del grid
	 * @param gridw valor de la altura del grid
	 * */
	void addComponente( Component comp, int gridx, int gridy, int gridw, int gridh ) {
        GridBagConstraints gbc = new GridBagConstraints();
        gbc.gridx = gridx;
        gbc.gridy = gridy;
        gbc.gridwidth = gridw;
        gbc.gridheight = gridh;
        gridbag.setConstraints( comp,gbc );
        this.add( comp );
    }

	/**
	 * Controla la accion dependiendo del Evento generado
	 * @param e Objeto <b>ActionEvent</b> con el evento generado
	 * */
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == b1) {//TODO cambiar aqui si modifica la estructura
			contenido.metadatos[0] = new String (tf1.getText());	//variable de estudio
			contenido.metadatos[5] = new String (tf2.getText());	//unidades
			contenido.metadatos[4] = new String (tf3.getText());	//fecha

			//contenido.muestraContenido();
			//contenido.setMetadatos(contenido.metadatos);	//contenido o cf ??	
			ArchivoXML xml = new ArchivoXML();
			xml.guardarFicheroXMLdeContenidoFichero(file, contenido);
			
        	frame.hide();
        }
	}

	/**
	 * @return Devuelve el valor de <i>metadatos</i>
	 * */
	public String[] getMetadatos() {
		return contenido.metadatos;
	}
}
